Imports System.Runtime.CompilerServices
Imports System.Collections

Public Module GenericExtensions

    <Extension()> _
    Public Function IsSomething(Of T As Class)(ByVal Subj As T) As Boolean
        Return Subj IsNot Nothing
    End Function

    <Extension()> _
    Public Function IsNothing(Of T As Class)(ByVal Subj As T) As Boolean
        Return Subj Is Nothing
    End Function

    <Extension()> _
    Public Function AddTo(Of T)(ByVal Subj As T, ByVal Collection As IList) As T
        'statt: Collection.Add(Obj)
        'implementiere ich: Subj.AddTo(Collection)
        'ermglicht verkettete Aufrufe: Subj.AddTo(Col1).AddTo(Col2)
        Collection.Add(Subj)
        Return Subj
    End Function

    ''' <summary>
    ''' konvertiert eine Comparison in ein IComparer-implementierendes Objekt
    ''' </summary>
    ''' <remarks>selbst einen Delegaten kann man also erweitern</remarks>
    <Extension()> _
    Public Function ToComparer(Of T)(ByVal Subj As Comparison(Of T)) As ComparisonComparer(Of T)
        Return New ComparisonComparer(Of T)(Subj)
    End Function

    ''' <summary>IComparer-implementierender Wrapper um eine Comparison </summary>
    Public Class ComparisonComparer(Of T) : Inherits Comparer(Of T)
        Private _Comparison As Comparison(Of T)
        Public Sub New(ByVal Comparison As Comparison(Of T))
            _Comparison = Comparison
        End Sub
        Public Overrides Function Compare(ByVal x As T, ByVal y As T) As Integer
            Return _Comparison(x, y)
        End Function
    End Class

End Module
