Imports System.Runtime.CompilerServices
Imports System.Collections

Public Module StringX

    Private _SB As New System.Text.StringBuilder

    <Extension()> _
    Public Function ConcatWith(ByVal Subj As Object, ByVal ParamArray Args() As Object) As String
        'Quasi-Umbau von Shared String.Concat() in eine Object-Function
        Return Subj.ToString & String.Concat(Args)
    End Function

    <Extension()> _
    Public Function Between(ByVal Delimiter As String, ByVal ParamArray Args() As Object) As String
        Return Args.Join(Delimiter)
    End Function

    <Extension()> _
    Public Function Between(ByVal Delimiter As String, ByVal Args As IEnumerable) As String
        Return Args.Join(Delimiter)
    End Function

    ''' <summary>
    ''' entspricht in etwa String.Join(Sources(), Delimiter), mit dem Unterschied, dasses fr 
    ''' alle Auflistungen anwendbar ist
    ''' </summary>
    <Extension()> _
    Private Function Join(ByVal Subj As IEnumerable, ByVal Delimiter As String) As String
        _SB.Remove(0, _SB.Length)
        With Subj.GetEnumerator
            If .MoveNext Then
                _SB.Append(If(.Current, "").ToString)
                While .MoveNext
                    _SB.Append(Delimiter).Append(If(.Current, "").ToString)
                End While
            Else
                Return ""
            End If
        End With
        Return _SB.ToString
    End Function

End Module
