Imports System.Runtime.CompilerServices

Public Module TreeNodeX

    Public Structure ApproachResult
        Public ReadOnly Node As TreeNode
        Public ReadOnly StepsDone As Integer
        Public Sub New(ByVal Node As TreeNode, ByVal StepsDone As Integer)
            Me.Node = Node
            Me.StepsDone = StepsDone
        End Sub
    End Structure

    ''' <summary>
    ''' sucht in Nodes und SubNodes anhand eines Pfades nach dem bezeichneten Node.
    ''' Bei Nichtexistenz des ZielNode den bergeordneten, in den der ZielNode zu erstellen wre
    ''' </summary>
    ''' <param name="PathSegments">Die Segmente des Pfades</param>
    ''' <returns>ein 
    ''' <seealso cref="ApproachResult"> ApproachResult, 
    ''' das den gefundenen Node enthlt, und die Anzahl abgearbeiteter Segmente
    ''' </seealso>
    ''' </returns>
    <Extension()> _
    Public Function Approach( _
            ByVal Nodes As TreeNodeCollection, ByVal PathSegments As IList(Of String)) As ApproachResult
        Dim Nd As TreeNode = Nothing
        For I = 0 To PathSegments.Count - 1
            If Nodes.ContainsKey(PathSegments(I)) Then
                Nd = Nodes(PathSegments(I)) 'Node per String-Key referenzieren.
                Nodes = Nd.Nodes
            Else
                Return New ApproachResult(Nd, I)
            End If
        Next
        Return New ApproachResult(Nd, PathSegments.Count)
    End Function

End Module
